﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.TradeRules
{

    [StorableClass]
    [Item("EMA", "Represents a EMA value.")]
    public class EMA : Symbol
    {
        private const int minimumArity = 1;
        private const int maximumArity = 1;

        public override int MinimumArity
        {
            get { return minimumArity; }
        }
        public override int MaximumArity
        {
            get { return maximumArity; }
        }

        [StorableConstructor]
        protected EMA(bool deserializing)
            : base(deserializing)
        {
            
        }
        protected EMA(EMA original, Cloner cloner)
            : base(original, cloner)
        {

        }
        public EMA() : this("EMA", "Represents a EMA value.") { }
        public EMA(string name, string description)
            : base(name, description)
        {
        }

        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new EMA(this, cloner);
        }
    }
}
